{
                Copyright (C) 1996-1997 by Artem A. Berman                   
                E-mail: art@aber.kherson.ua                             
 
  This components can be freely used and distributed in commercial and  
  private environments, provied this notice is not modified in any way. 

  Version 1.0. Date last modified:  05/03/96                            
  Version 1.01. Date last modified:  7-Apr-97                           
           + Replaced TExplorerBox with new version
           + Rewrited 60 % of code
           + Replaced TWin95SpeedButton to Borland's
             TSpeedButton                                              }

unit Expdlg;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Explorer, Buttons, FileCtrl;

type
  TExplorerDlg = class(TForm)
    ExplorerBox1: TExplorerBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    procedure DriveComboBox1Change(Sender: TObject);
    procedure ExplorerBox1FileChange(Sender: TObject);
    procedure FilterComboBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExplorerBox1DblClick(Sender: TObject);
    procedure ExplorerBox1DirChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ExplorerBox1Enter(Sender: TObject);
    procedure ExplorerBox1Exit(Sender: TObject);
  end;

var
  ExplorerDlg: TExplorerDlg;

implementation

{$R *.DFM}

procedure TExplorerDlg.DriveComboBox1Change(Sender: TObject);
begin
  try
    ChDir(DriveComboBox1.Drive + ':\');
  except

    if MessageDlg('Drive ' + DriveComboBox1.Drive + ': is not ready. Retry?',
               mtError, [mbYes, mbNo], 0) = mrYes then
                      DriveComboBox1Change(Sender)
                        else
                      DriveComboBox1.Drive := ExplorerBox1.Directory[1];
    exit;
  end;
  ExplorerBox1.Directory := DriveComboBox1.Drive + ':\'
end;

procedure TExplorerDlg.SpeedButton2Click(Sender: TObject);
var
  strResult: string;
begin
  strResult := InputBox('Create Folder', 'Name', '');
  if strResult <> '' then
  begin
    MkDir(ExplorerBox1.Directory + strResult);
    ExplorerBox1.RePaint
  end;
  ExplorerBox1.SetFocus;
end;

procedure TExplorerDlg.SpeedButton3Click(Sender: TObject);
begin
  if ExplorerBox1.ItemIndex = -1 then exit;
  if MessageDlg('Are you sure want to do that?', mtConfirmation, [mbOk, mbCancel], 0) = mrOk
  then begin
         if not DeleteFile(ExplorerBox1.Directory +
               ExplorerBox1.Items.Strings[ExplorerBox1.ItemIndex]) then
         RmDir(ExplorerBox1.Directory +
               ExplorerBox1.Items.Strings[ExplorerBox1.ItemIndex]);
         ExplorerBox1.RePaint
  end;
  ExplorerBox1.SetFocus;
end;

procedure TExplorerDlg.SpeedButton1Click(Sender: TObject);
var NewDir: TFileName;
begin
  NewDir := ExplorerBox1.Directory;
  Dec(NewDir[0]);
  NewDir := Copy(NewDir, 0, Length(NewDir) - ExplorerBox1.RPos('\', NewDir));
  ExplorerBox1.Directory := NewDir;
  if Length(NewDir) = 3 then SpeedButton1.Enabled := False;
  ExplorerBox1.SetFocus;
end;

procedure TExplorerDlg.ExplorerBox1FileChange(Sender: TObject);
begin
  Edit1.Text := ExplorerBox1.Items.Strings[ExplorerBox1.ItemIndex];
end;

procedure TExplorerDlg.FilterComboBox1Change(Sender: TObject);
begin
  ExplorerBox1.Filter := FilterComboBox1.Mask;
  ExplorerBox1.RePaint
end;

procedure TExplorerDlg.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TExplorerDlg.FormCreate(Sender: TObject);
begin
  DriveComboBox1.Drive := ExplorerBox1.Directory[1];
end;

procedure TExplorerDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if (ExplorerBox1.FileName = '') and (ModalResult = mrOk) then Action := caNone
end;

procedure TExplorerDlg.ExplorerBox1DblClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TExplorerDlg.ExplorerBox1DirChange(Sender: TObject);
var NewDir: TFileName;
begin
  NewDir := ExplorerBox1.Directory;
  if Length(NewDir) = 3 then SpeedButton1.Enabled := False else
  SpeedButton1.Enabled := True;
end;

procedure TExplorerDlg.FormActivate(Sender: TObject);
var NewDir: TFileName;
begin
  NewDir := ExplorerBox1.Directory;
  if Length(NewDir) = 3 then SpeedButton1.Enabled := False;
end;

procedure TExplorerDlg.ExplorerBox1Enter(Sender: TObject);
begin
  Button1.Default := False;
end;

procedure TExplorerDlg.ExplorerBox1Exit(Sender: TObject);
begin
  Button1.Default := True;
end;

end.
